plugins {
    alias(libs.plugins.androidApplication)
    //id("com.android.application")
    id("com.google.gms.google-services")
}

android {
    namespace = "edu.uoc.tfg.yourlovelypet"
    compileSdk = 34

    defaultConfig {
        applicationId = "edu.uoc.tfg.yourlovelypet"
        minSdk = 23
        targetSdk = 34
        versionCode = 1
        versionName = "1.0"
        testInstrumentationRunner = "androidx.test.runner.AndroidJUnitRunner"
    }

    buildTypes {
        release {
            isMinifyEnabled = false
            proguardFiles(
                getDefaultProguardFile("proguard-android-optimize.txt"),
                "proguard-rules.pro"
            )
        }
    }
    compileOptions {
        sourceCompatibility = JavaVersion.VERSION_1_8
        targetCompatibility = JavaVersion.VERSION_1_8
    }
    buildFeatures {
        viewBinding = true
    }
}

dependencies {

    implementation(libs.appcompat)
    implementation(libs.activity)
    implementation(libs.constraintlayout) // ConstraintLayout
    implementation(libs.recyclerview) // RecyclerView
    implementation(libs.lifecycle.viewmodel) // ViewModel
    implementation(libs.lifecycle.livedata) // LiveData
    implementation(libs.material) // Material Design 3

    // Navigation component
    implementation(libs.navigation.fragment)
    implementation(libs.navigation.ui)

    // Tests
    testImplementation(libs.junit)
    androidTestImplementation(libs.ext.junit)
    androidTestImplementation(libs.espresso.core)
    androidTestImplementation(libs.espresso.contrib) {
        exclude("com.google.protobuf", "protobuf-lite") }
    androidTestImplementation(libs.espresso.intents)
    androidTestImplementation(libs.espresso.idlingConcurrent)
    androidTestImplementation(libs.androidxTest.rules)
    androidTestImplementation(libs.androidxTest.runner)
    androidTestImplementation(libs.mockito.core)
    androidTestImplementation(libs.mockito.android)
    androidTestImplementation(libs.core.testing)

    // Firebase
    implementation(platform(libs.firebase.bom)) // BoM (Bill of Materials) Firebase (version control)
    implementation(libs.firebase.analytics) // Firebase Analytics
    implementation(libs.firebase.auth) // Firebase Authentication
    implementation(libs.firebase.firestore) // Firebase Firestore
    implementation(libs.firebase.storage) // Firebase Storage

    // Glide
    implementation(libs.glide)
    annotationProcessor(libs.compiler)
    implementation(libs.glide.transformations) // Glide transformations

    // Google play services
    implementation(libs.play.services.maps) // Maps
    implementation(libs.play.services.location) // Location
    implementation(libs.places) // Places
}