package edu.uoc.tfg.yourlovelypet.views.dialogs;

import android.app.Dialog;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import edu.uoc.tfg.yourlovelypet.R;
import edu.uoc.tfg.yourlovelypet.databinding.FragmentSignupWelcomeDialogBinding;

public class SignupWelcomeDialogFragment extends DialogFragment {

    private FragmentSignupWelcomeDialogBinding binding;
    private static final String ARG_NAME = "name";
    private String userName;

    public SignupWelcomeDialogFragment() {
        // Required empty public constructor
    }

    public static SignupWelcomeDialogFragment newInstance(String param) {
        SignupWelcomeDialogFragment fragment = new SignupWelcomeDialogFragment();
        Bundle args = new Bundle();
        args.putString(ARG_NAME, param);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            userName = getArguments().getString(ARG_NAME);
        }
    }

    @NonNull
    @Override
    public Dialog onCreateDialog(@Nullable Bundle savedInstanceState) {
        Dialog dialog = super.onCreateDialog(savedInstanceState);
        if (dialog.getWindow() != null) {
            dialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
            dialog.getWindow().setBackgroundDrawableResource(R.drawable.custom_bg_white);
        }
        return dialog;
    }

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        binding = FragmentSignupWelcomeDialogBinding.inflate(getLayoutInflater(), container, false);
        // Set userName into welcome message
        String msg = userName + "!";
        binding.textView2.setText(msg);
        return binding.getRoot();
    }
}