package edu.uoc.tfg.yourlovelypet.views.fragments;

import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import edu.uoc.tfg.yourlovelypet.databinding.FragmentCalendarBinding;
import edu.uoc.tfg.yourlovelypet.model.Pet;
import edu.uoc.tfg.yourlovelypet.viewModel.MainViewModel;

public class CalendarFragment extends Fragment {

    private static final String TAG = "[CalendarFragment]";
    private FragmentCalendarBinding binding;
    private MainViewModel mainViewModel;
    private static final String ARG_PET_ID = "petId";
    private String receivedPetId;
    private Pet currentPet;

    public CalendarFragment() {}

    public static CalendarFragment newInstance(String param) {
        CalendarFragment fragment = new CalendarFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PET_ID, param);
        fragment.setArguments(args);
        return fragment;
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            receivedPetId = getArguments().getString(ARG_PET_ID);
            Log.d(TAG,"Receive petId: " + receivedPetId + " from PetAdapter/HomeFragment");
        }
    }

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        binding = FragmentCalendarBinding.inflate(getLayoutInflater(), container, false);
        return binding.getRoot();
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        mainViewModel = new ViewModelProvider(requireActivity()).get(MainViewModel.class);
        currentPet = mainViewModel.getPetById(receivedPetId);
        binding.textViewPetName.setText(currentPet.getPetName()); // TODO implementar observer por si cambia petName
    }
}