package edu.uoc.tfg.yourlovelypet;

import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import edu.uoc.tfg.yourlovelypet.model.Post;

public class PostUnitTest {
    private Post post;

    @Before
    public void setUp() {
        post = new Post("postTitle1", "postAuthorName1", "22/11/2022", "Test body 1", "replyToId1_123456");
    }

    @Test
    public void testGetId() {
        assertNull(post.getId());
        post.setId("123456");
        assertEquals("123456", post.getId());
    }

    @Test
    public void testGetTitle() {
        assertEquals("postTitle1", post.getTitle());
        post.setTitle("postTitle2");
        assertEquals("postTitle2", post.getTitle());
    }

    @Test
    public void testGetAuthor() {
        assertEquals("postAuthorName1", post.getAuthor());
        post.setAuthor("postAuthorName2");
        assertEquals("postAuthorName2", post.getAuthor());
    }

    @Test
    public void testGetDate() {
        assertEquals("22/11/2022", post.getDate());
        post.setDate("22/11/2023");
        assertEquals("22/11/2023", post.getDate());
    }

    @Test
    public void testGetBody() {
        assertEquals("Test body 1", post.getBody());
        post.setBody("Test body 2");
        assertEquals("Test body 2", post.getBody());
    }

    @Test
    public void testGetReplyToId() {
        assertEquals("replyToId1_123456", post.getReplyToId());
        post.setReplyToId("replyToId1_123457");
        assertEquals("replyToId1_123457", post.getReplyToId());
    }

    @Test
    public void testSetters() {
        post.setId("654321");
        post.setTitle("postTitle3");
        post.setAuthor("postAuthorName3");
        post.setDate("22/11/2020");
        post.setBody("Test body 3");
        post.setReplyToId("replyToId1_123458");
        assertEquals("654321", post.getId());
        assertEquals("postTitle3", post.getTitle());
        assertEquals("postAuthorName3", post.getAuthor());
        assertEquals("22/11/2020", post.getDate());
        assertEquals("Test body 3", post.getBody());
        assertEquals("replyToId1_123458", post.getReplyToId());
    }
}